scala.tools.nsc.transform

# Mixin

###
Related Doc: package transform

#### abstract class Mixin extends SubComponent with InfoTransform with TreeDSL

Source
  Mixin.scala

Linear Supertypes
TreeDSL, InfoTransform, Transform, SubComponent, AnyRef, Any
Known Subclasses
mixer
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Mixin
2. TreeDSL
3. InfoTransform
4. Transform
5. SubComponent
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Mixin()

### Type Members

1. #### class MixinTransformer extends Global.Transformer

2. #### class Phase extends InfoTransform.Phase

   Definition Classes
     InfoTransform

3. #### abstract class StdPhase extends GlobalPhase

   A standard phase template

   A standard phase template

   Definition Classes
     SubComponent

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     TreeDSL

2. #### abstract val runsAfter: List[String]

   Names of phases that must run before this phase.

   Names of phases that must run before this phase.

   Definition Classes
     SubComponent

3. #### abstract val runsRightAfter: Option[String]

   Name of the phase that this phase must follow immediately.

   Name of the phase that this phase must follow immediately.

   Definition Classes
     SubComponent

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Mixin to any2stringadd[Mixin] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Mixin, B)

   Implicit information
     This member is added by an implicit conversion from Mixin to ArrowAssoc[Mixin] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object CODE

   Definition Classes
     TreeDSL

7. #### def addLateInterfaceMembers(clazz: Global.Symbol): Unit

   Add getters and setters for all non-module fields of an implementation class to its interface unless they are already present.

   Add getters and setters for all non-module fields of an implementation class to its interface unless they are already present. This is done only once per class. The mixedin flag is used to remember whether late members have been added to an interface.

   - lazy fields don't get a setter.

8. #### def addMember(clazz: Global.Symbol, member: Global.Symbol): Global.Symbol

   Add given member to given class, and mark member as mixed-in.

9. #### def addMixedinMembers(clazz: Global.Symbol, unit: Global.CompilationUnit): Unit

   Add all members to be mixed in into a (non-trait-) class These are: for every mixin trait T that is not also inherited by the superclass: add late interface members to T and then:

   Add all members to be mixed in into a (non-trait-) class These are: for every mixin trait T that is not also inherited by the superclass: add late interface members to T and then:

   - if a member M of T is forwarded to the implementation class, add a forwarder for M unless one exists already. The alias of the forwarder is the static member it forwards to.
   - for every abstract accessor in T, add a field and an implementation for that accessor
   - for every super accessor in T, add an implementation of that accessor
   - for every module in T, add a module

10. #### final def afterOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

12. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

13. #### def changesBaseClasses: Boolean

    Attributes
      protected
    Definition Classes
      InfoTransform

14. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

15. #### def cloneAndAddMember(mixinClass: Global.Symbol, mixinMember: Global.Symbol, clazz: Global.Symbol): Global.Symbol

16. #### def cloneBeforeErasure(mixinClass: Global.Symbol, mixinMember: Global.Symbol, clazz: Global.Symbol): Global.Symbol

17. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

18. #### def ensuring(cond: (Mixin) ⇒ Boolean, msg: ⇒ Any): Mixin

    Implicit information
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: (Mixin) ⇒ Boolean): Mixin

    Implicit information
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean, msg: ⇒ Any): Mixin

    Implicit information
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean): Mixin

    Implicit information
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

24. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

25. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Mixin to StringFormat[Mixin] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

27. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    returns

      the hash code value for this object.

    Definition Classes
      SubComponent → AnyRef → Any

28. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

29. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

30. #### def isConcreteAccessor(member: Global.Symbol): Boolean

31. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

32. #### def isOverriddenAccessor(member: Global.Symbol, bcs: List[Global.Symbol]): Boolean

    Is member overridden (either directly or via a bridge) in base class sequence `bcs`?

33. #### def keepsTypeParams: Boolean

    Attributes
      protected
    Definition Classes
      InfoTransform

34. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      InfoTransform → Transform → SubComponent

36. #### def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Attributes
      protected
    Definition Classes
      Mixin → Transform

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

40. #### val phaseName: String

    The name of the phase:

    The name of the phase:

    Definition Classes
      Mixin → SubComponent

41. #### def phaseNewFlags: Long

    The phase might set the following new flags:

    The phase might set the following new flags:

    Definition Classes
      Mixin → SubComponent

42. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

43. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

44. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

45. #### def singleUseFields(templ: Global.Template): Map[Global.Symbol, List[Global.Symbol]]

    Return a map of single-use fields to the lazy value that uses them during initialization.

    Return a map of single-use fields to the lazy value that uses them during initialization. Each field has to be private and defined in the enclosing class, and there must be exactly one lazy value using it.

    Such fields will be nulled after the initializer has memoized the lazy value.

46. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

47. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

48. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

49. #### def transformInfo(sym: Global.Symbol, tp: Global.Type): Global.Type

    The info transform for this phase does the following:

    The info transform for this phase does the following:

    - The parents of every class are mapped from implementation class to interface
    - Implementation classes become modules that inherit nothing and that define all.
    Definition Classes
      Mixin → InfoTransform

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### def →[B](y: B): (Mixin, B)

    Implicit information
      This member is added by an implicit conversion from Mixin to ArrowAssoc[Mixin] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from TreeDSL

### Inherited from InfoTransform

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Mixin to any2stringadd[Mixin]

### Inherited by implicit conversion StringFormat from Mixin to StringFormat[Mixin]

### Inherited by implicit conversion Ensuring from Mixin to Ensuring[Mixin]

### Inherited by implicit conversion ArrowAssoc from Mixin to ArrowAssoc[Mixin]

### Ungrouped